//A program to test starting as many threads as you have processors

public class ProcTestR
{
  public static void main(String [] args)
  {
    //Get the number of available processors on your system
    int processors = Runtime.getRuntime().availableProcessors();

    //Create array to hold thread objects
    TestRunnable [] t = new TestRunnable[processors];

    //Allocate and start each thread
    for( int i = 0; i < processors; i++ )
    {
      t[i] = new TestRunnable();

      //This starts a thread.  Don't call run to start a thread!
      (new Thread(t[i])).start();
    }
  }
}
